<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_template".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanTemplate".
 *
 * Columns in table "scan_template" available as properties of the model,
 * followed by relations of table "scan_template" available as properties of the model.
 *
 * @property integer $id
 * @property integer $version
 * @property string $internal_name
 * @property integer $scan_template_type_id
 * @property string $name
 * @property integer $active
 * @property integer $shown_in_pdt
 * @property integer $shown_in_pdl
 * @property string $date_added
 * @property string $date_updated
 *
 * @property ScanRequest[] $scanRequests
 * @property ScanTemplateListingType[] $scanTemplateListingTypes
 * @property ScanTemplateListingTypeVersion[] $scanTemplateListingTypeVersions
 */
abstract class BaseScanTemplate extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_template';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanTemplate|ScanTemplates', $n);
    }

    public static function representingColumn()
    {
        return 'internal_name';
    }

    public function rules()
    {
        return array(
            array('internal_name, name, active, date_added, date_updated', 'required'),
            array(
                'version, scan_template_type_id, active, shown_in_pdt, shown_in_pdl',
                'numerical',
                'integerOnly' => true
            ),
            array('internal_name, name', 'length', 'max' => 45),
            array(
                'version, scan_template_type_id, shown_in_pdt, shown_in_pdl',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, version, internal_name, scan_template_type_id, name, active, shown_in_pdt, shown_in_pdl, ' .
                    'date_added, date_updated',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'scanRequests' => array(self::HAS_MANY, 'ScanRequest', 'scan_template_id'),
            'scanTemplateType' => array(self::BELONGS_TO, 'ScanTemplateType', 'scan_template_type_id'),
            'scanTemplateListingTypes' => array(self::HAS_MANY, 'ScanTemplateListingType', 'scan_template_id'),
            'scanTemplateListingTypeVersions' => array(
                self::HAS_MANY,
                'ScanTemplateListingTypeVersion',
                'scan_template_id'
            ),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'version' => Yii::t('app', 'Version'),
            'internal_name' => Yii::t('app', 'Internal Name'),
            'scan_template_type_id' => Yii::t('app', 'Type'),
            'name' => Yii::t('app', 'Name'),
            'active' => Yii::t('app', 'Active'),
            'shown_in_pdt' => Yii::t('app', 'Shown In PDT'),
            'shown_in_pdl' => Yii::t('app', 'Shown In PDL'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'scanRequests' => null,
            'scanTemplateListingTypes' => null,
            'scanTemplateListingTypeVersions' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('version', $this->version);
        $criteria->compare('internal_name', $this->internal_name, true);
        $criteria->compare('scan_template_type_id', $this->scan_template_type_id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('active', $this->active);
        $criteria->compare('shown_in_pdt', $this->shown_in_pdt);
        $criteria->compare('shown_in_pdl', $this->shown_in_pdl);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
